// EventVW.cpp : implementation file
//

#include "stdafx.h"
#include <afxcview.h>
#include "opchda.h"
#include "opchda_error.h"
#include "wthdasvrapi.h"

#include "HDATest1.h"
#include "EventVW.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEventVW

IMPLEMENT_DYNCREATE(CEventVW, CListView)

CEventVW::CEventVW()
{
}

CEventVW::~CEventVW()
{
}


BEGIN_MESSAGE_MAP(CEventVW, CListView)
	//{{AFX_MSG_MAP(CEventVW)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEventVW drawing

void CEventVW::OnDraw(CDC* pDC)
{
	CDocument* pDoc = GetDocument();
	// TODO: add draw code here
}

/////////////////////////////////////////////////////////////////////////////
// CEventVW diagnostics

#ifdef _DEBUG
void CEventVW::AssertValid() const
{
	CListView::AssertValid();
}

void CEventVW::Dump(CDumpContext& dc) const
{
	CListView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CEventVW message handlers


BOOL CEventVW::PreCreateWindow(CREATESTRUCT& cs) 
{
	cs.style |= LVS_REPORT;

	return CListView::PreCreateWindow(cs);
}

void CEventVW::OnInitialUpdate() 
{
	LV_COLUMN		lvcolumn;
	CRect	rect;
	
	CHDATest1App *pApp;

	pApp = (CHDATest1App *)AfxGetApp();
	pApp->pEventView = this;

	GetWindowRect(&rect);

	lvcolumn.mask = LVCF_FMT |  LVCF_TEXT | LVCF_WIDTH;
	lvcolumn.fmt = LVCFMT_LEFT;
	lvcolumn.pszText = "Event Messages from WtHDAsvr.dll";
	lvcolumn.iSubItem = 0;
	lvcolumn.cx = rect.Width();
	GetListCtrl().InsertColumn(0, &lvcolumn);  // assumes return value is OK.

	LogFile.Open ("c:\\hdatest1.txt", CFile::modeWrite | CFile::modeCreate, &e); 

}

void CEventVW::EventHandler (char *pMsg)
{

	LogFile.Write (pMsg, strlen(pMsg));
	LogFile.Write ("\r\n", 2);

	CListCtrl& theCtrl = GetListCtrl();

	while (theCtrl.GetItemCount() > 500)
		theCtrl.DeleteItem(0);
	theCtrl.InsertItem (theCtrl.GetItemCount(), pMsg);

	theCtrl.RedrawItems(0,theCtrl.GetItemCount());

}


void CEventVW::OnDestroy() 
{
	LogFile.Close();

	CListView::OnDestroy();
	
	
}
