VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   BeginProperty Font 
      Name            =   "MS Sans Serif"
      Size            =   24
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.Label Label1 
      Caption         =   "VbHDASvr"
      Height          =   615
      Left            =   1080
      TabIndex        =   0
      Top             =   1200
      Width           =   2535
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim GUID(16) As Byte
Dim SvrName(100) As Byte
Dim SvrDesc(100) As Byte
Dim ExePath(100) As Byte
Dim VendorInfo(100) As Byte

Private Sub Form_Load()
Dim error As Long
Dim Id As Long
Dim Name(100) As Byte
Dim Descrip(100) As Byte
Dim VarType As Long
Dim QChar As Byte

' GUID from GUIDGEN
' {4883D210-AC14-11d7-8AAA-000476323C57}
'{ 0x4883d210, 0xac14, 0x11d7, { 0x8a, 0xaa, 0x0, 0x4, 0x76, 0x32, 0x3c, 0x57 } };
GUIDToByte "{4883D210-AC14-11d7-8AAA-000476323C57}", GUID()
StringToByte "VbHDAsvr", SvrName()
StringToByte "VB Example HDA Server", SvrDesc()
StringToByte App.Path & "\" & App.EXEName & ".exe", ExePath()
StringToByte "ABC Corp.", VendorInfo()

error = HDAUpdateRegistry(GUID(0), SvrName(0), SvrDesc(0), ExePath(0))

error = SetHDAVendorInfo(VendorInfo(0))
error = InitWtHDAsvr(GUID(0), 1000)
QChar = 46  'Set Qualifying character to .
error = SetHDAQualifier(QChar)

error = EnableGetTimeStampCallback(AddressOf MyTimeStampCallback)
error = EnableGetPreviousTimeStampCallback(AddressOf MyPrevTimeStampCallback)
error = EnableGetNextTimeStampCallback(AddressOf MyNextTimeStampCallback)
error = EnableReadAtCallback(AddressOf MyReadAtCallback)
error = EnableReadCurrentAttributeCallback(AddressOf MyCurrentAttributeCallback)
error = EnableReadAttributeAtCallback(AddressOf MyReadAttributeCallback)
error = EnableReadProcessedCallback(AddressOf MyReadProcessedCallback)
error = EnablePrepareAggregatesCallback(AddressOf MyPrepareAggregatesCallback)


'
'Define all the attributes that we support
'
Id = 1 'OPCHDA_DATA_TYPE
StringToByte "Data Type", Name()
StringToByte "HDA Item Data Type", Descrip()
VarType = 2 'VT_I2
error = DefineHDAAttribute(Id, Name(0), Descrip(0), VarType, False)

Id = 2 'OPCHDA_DESCRIPTION
StringToByte "Description", Name()
StringToByte "HDA Item Description", Descrip()
VarType = 8 'VT_BSTR
error = DefineHDAAttribute(Id, Name(0), Descrip(0), VarType, False)

Id = 3 'OPCHDA_ENG_UNITS
StringToByte "Engineering Units", Name()
StringToByte "HDA Item Engineering Units", Descrip()
VarType = 8 'VT_BSTR
error = DefineHDAAttribute(Id, Name(0), Descrip(0), VarType, False)

Id = 13 'OPCHDA_ITEMID
StringToByte "Item ID", Name()
StringToByte "HDA Item Name", Descrip()
VarType = 8 'VT_BSTR
error = DefineHDAAttribute(Id, Name(0), Descrip(0), VarType, False)

'
' Define the Aggregates
'
Id = 3 'OPCHDA_AVERAGE
StringToByte "Average", Name()
StringToByte "Average Random Value", Descrip()
error = DefineHDAAggregate(Id, Name(0), Descrip(0))

Id = 5 'OPCHDA_COUNT
StringToByte "Count", Name()
StringToByte "Number of Random Values", Descrip()
error = DefineHDAAggregate(Id, Name(0), Descrip(0))


'
' Define our list of items
'
StringToByte "A.A.A", Name()
hItem(0) = DefineHDAItem(Name(0))

StringToByte "A.A.B", Name()
hItem(1) = DefineHDAItem(Name(0))

StringToByte "A.A.C", Name()
hItem(2) = DefineHDAItem(Name(0))

StringToByte "A.B.A", Name()
hItem(3) = DefineHDAItem(Name(0))

StringToByte "A.B.B", Name()
hItem(4) = DefineHDAItem(Name(0))

StringToByte "A.B.C", Name()
hItem(5) = DefineHDAItem(Name(0))

StringToByte "A.C.A", Name()
hItem(6) = DefineHDAItem(Name(0))

StringToByte "A.C.B", Name()
hItem(7) = DefineHDAItem(Name(0))

StringToByte "A.C.C", Name()
hItem(8) = DefineHDAItem(Name(0))

End Sub
