Attribute VB_Name = "Module2"
Public hItem(9) As Long


Sub MyTimeStampCallback(ByVal hItem As Long, ByRef StartTime As FileTime, ByRef EndTime As FileTime, ByVal MaxValues As Long, ByRef TimeStamp As FileTime, ByRef NumberOfValues As Long)
Dim vbStart As Date
Dim vbEnd As Date
Dim error As Long
Dim temp As Date
Dim Times(100) As FileTime
Dim i As Integer

error = HDAConvertFileTimeToVBDate(StartTime, vbStart)
error = HDAConvertFileTimeToVBDate(EndTime, vbEnd)
If vbStart > vbEnd Then
    temp = vbEnd
    vbEnd = vbStart
    vbStart = temp
    End If
    
' just generate some random times to return
For i = 0 To MaxValues - 1
    temp = vbStart + (0.000225 * i)
    error = HDAConvertVBDateToFileTime(temp, Times(i))
    NumberOfValues = i + 1
    If i > 99 Then
        i = MaxValues
        End If
    Next i
  
Call CopyMemory(TimeStamp, Times(0), NumberOfValues * 8)

End Sub

Sub MyPrevTimeStampCallback(ByVal hItem As Long, ByVal Time As Double, ByRef TimeStamp As FileTime, ByRef hResult As Long)
Dim vbFTime As FileTime
Dim vbTime As Date
Dim temp As Date
Dim error As Long

Call CopyMemory(vbFTime, Time, 8)
error = HDAConvertFileTimeToVBDate(vbFTime, vbTime)
temp = vbTime - 0.000225
error = HDAConvertVBDateToFileTime(temp, TimeStamp)
hResult = 0

End Sub

Sub MyNextTimeStampCallback(ByVal hItem As Long, ByVal Time As Double, ByRef TimeStamp As FileTime, ByRef hResult As Long)
Dim vbFTime As FileTime
Dim vbTime As Date
Dim temp As Date
Dim error As Long

Call CopyMemory(vbFTime, Time, 8)
error = HDAConvertFileTimeToVBDate(vbFTime, vbTime)
temp = vbTime + 0.000225
error = HDAConvertVBDateToFileTime(temp, TimeStamp)
hResult = 0

End Sub

Sub MyReadAtCallback(ByVal hItem As Long, ByVal Time As Double, ByRef Value As Variant, ByRef Quality As Long, ByRef hResult As Long)
Dim vbFTime As FileTime
Dim vbTime As Date
Dim error As Long

Call CopyMemory(vbFTime, Time, 8)
error = HDAConvertFileTimeToVBDate(vbFTime, vbTime)

Value = Rnd()
Quality = 4
hResult = 0

End Sub

Sub MyCurrentAttributeCallback(ByVal ItemHandle As Long, ByVal Id As Long, ByRef Time As FileTime, ByRef Value As Variant, ByRef hResult As Long)
Dim vbTime As Date
Dim error As Long
Dim temp As Integer

hResult = -1073475572   'OPC_E_INVALIDATTRID
error = HDAConvertFileTimeToVBDate(Time, vbTime)

If Id = 1 Then
            'OPCHDA_DATA_TYPE
    temp = 4  ' VT_R4
    Value = temp
    hResult = 0
    End If
    
If Id = 2 Then
            'OPCHDA_DESCRIPTION
    Value = "Random Floating Point Values"
    hResult = 0
    End If
    
If Id = 3 Then
            'OPCHDA_ENG_UNITS
    Value = "Counts"
    hResult = 0
    End If
    
If Id = 13 Then
            'OPCHDA_ITEMID
    Value = "UNKNOWN"
    If ItemHandle = hItem(0) Then
        Value = "A.A.A"
        End If
    If ItemHandle = hItem(1) Then
        Value = "A.A.B"
        End If
    If ItemHandle = hItem(2) Then
        Value = "A.A.C"
        End If
    If ItemHandle = hItem(3) Then
        Value = "A.B.A"
        End If
    If ItemHandle = hItem(4) Then
        Value = "A.B.B"
        End If
    If ItemHandle = hItem(5) Then
        Value = "A.B.C"
        End If
    If ItemHandle = hItem(6) Then
        Value = "A.C.A"
        End If
    If ItemHandle = hItem(7) Then
        Value = "A.C.B"
        End If
    If ItemHandle = hItem(8) Then
        Value = "A.C.C"
        End If
    hResult = 0
       
    End If
    
   
End Sub

Sub MyReadAttributeCallback(ByVal hItem As Long, ByVal Id As Long, ByVal TimeStamp As Double, ByRef Value As Variant, ByRef hResult As Long)
Dim vbFTime As FileTime
Dim vbTime As Date
Dim error As Long

Call CopyMemory(vbFTime, TimeStamp, 8)
Call MyCurrentAttributeCallback(hItem, Id, vbFTime, Value, hResult)
End Sub

Sub MyPrepareAggregatesCallback(ByVal hItem As Long, ByVal Id As Long, ByVal StartTime As Double, ByVal EndTime As Double, ByVal ReSampleInterval As Double, ByRef NumberOfValues As Long)

End Sub

Sub MyReadProcessedCallback(ByVal hItem As Long, ByVal Id As Long, ByRef StartTime As FileTime, ByRef EndTime As FileTime, ByRef Value As Variant, ByRef Quality As Long, ByRef hResult As Long)
Dim vbStart As Date
Dim vbEnd As Date
Dim error As Long

error = HDAConvertFileTimeToVBDate(StartTime, vbStart)
error = HDAConvertFileTimeToVBDate(EndTime, vbEnd)

hResult = -1273475572   'OPC_E_NOT_AVAIL

If Id = 3 Then
        'OPCHDA_AVERAGE
        Value = Rnd()
        Quality = 8 'OPCHDA_CALCULATED
        hResult = 0
    End If
    
If Id = 5 Then
        'OPCHDA_COUNT
        Value = Rnd()
        Quality = 8 'OPCHDA_CALCULATED
        hResult = 0
    End If

End Sub





